<?php
/* $Id: function.inc.php,v 1.8 2006/08/11 12:08:48 kx Exp $ */

function banner_rotate($zone,$number=1,$rand=false)
{
    global $db, $MODULE_VARS;
    global $catalogue, $sub, $cc, $message;
    global $HTTP_FILES_PATH, $admin_mode;
    global $HTTP_HOST, $REQUEST_URI;

    if (!$zone) return;

    extract ($MODULE_VARS['banner']);

    for($nmb=1;$nmb<=$number;$nmb++)
    {

        $sub_cond = banner_getparentsections ($sub,"e.Section","e.Section='$sub' ");

        $selectmain = "SELECT a.Message_ID FROM Message${CAMPAIGN_TABLE} AS a, Banner_CampaignZone AS b WHERE a.Main=1 AND a.Checked=1 AND b.Zone_ID='$zone' AND a.Message_ID=b.Campaign_ID ORDER BY a.LastUpdated DESC";
        $res = $db->get_var($selectmain);

        if ($db->num_rows)
        {
            $campaign_id = $res;
            $campaign_cond_ext = " AND c.Message_ID=".$campaign_id;
        }

        $selectsize = $db->get_row("SELECT Size, BannerDivider FROM Message${ZONE_TABLE} WHERE Message_ID=$zone");
        $size_id=$selectsize->Size;
        $banner_divider=$selectsize->BannerDivider;
        if ($nmb!="1")
        {
            $final_code.=$banner_divider;
        }

        $curday = date("w");
        if (!$curday)
        {
            $curday = 7;
        }
        if ($old_banID){
            $multiCond="";
            foreach ($old_banID as $cur) $multiCond.=" AND a.Banner_ID<>$cur";
        }


        $fields = "a.Banner_ID, a.Campaign_ID, d.Type, h.BannerSize_Name, d.File, d.Alt, d.Text, g.Field_ID, d.NewWindow";

        $tables = "(Banner_CampaignBanner AS a, Banner_CampaignZone AS b, Message${CAMPAIGN_TABLE} AS c, Message${BANNER_TABLE} as d, Message${ZONE_TABLE} AS e, Message${SCRIPT_TABLE} AS f, Field AS g) LEFT JOIN Classificator_BannerSize AS h ON h.BannerSize_ID=d.Size LEFT JOIN Message${SCRIPT_EXCLUSION_TABLE} AS i ON f.Message_ID=i.Script";

        $campaign_cond = "((c.Start<=IF(c.Start IS NOT NULL,NOW(),0) AND c.Stop>IF(c.Stop IS NOT NULL,NOW(),0)) AND IF(c.Shows IS NOT NULL,(c.Showed+1),0)<=IF(c.Shows IS NOT NULL,c.Shows,0)) AND a.Campaign_ID=b.Campaign_ID AND c.Checked=1 AND a.Campaign_ID=c.Message_ID".$campaign_cond_ext;

		$banner_cond = "AND f.Message_ID = d.Script AND d.Status=1 AND d.Checked=1 AND ".($size_id?"c.Size=d.Size AND d.Size=e.Size":"c.Size IS NULL AND d.Size IS NULL AND e.Size IS NULL")." AND a.Banner_ID=d.Message_ID AND f.Message_ID=d.Script ".($multiCond?"$multiCond":"")."";

	$script_cond = "AND
						f.TimeZone".(date("H")+1)."=1
					AND
						f.Day".$curday."=1
					AND
					(
						(
							(
								i.Site!='$catalogue'
							OR
								i.Site IS NULL
							)
							AND
								i.Section IS NULL
							AND
								i.Class IS NULL
							AND
								i.Object IS NULL
						)

						OR
						(
							(
								i.Section!='$sub'
							OR
								i.Section IS NULL
							)
							AND
								i.Class IS NULL
							AND
								i.Object IS NULL
						)

						OR
						(
								i.Class!='$cc'
							AND
								i.Object IS NULL
						)

						OR
						(
								i.Class IS NULL
							AND
								i.Object!='$message'
						)

						OR
						(
								i.Object!='$message'
							OR
							(
								i.Class!='$cc'
								AND
								i.Object IS NOT NULL
							)

						)


						OR
						(
								i.Site IS NULL
							AND
								i.Section IS NULL
							AND
								i.Class IS NULL
							AND
								i.Object IS NULL
						)
					)";


		$zone_cond = "AND b.Zone_ID='$zone' AND b.Zone_ID=e.Message_ID AND ((e.Site='$catalogue' AND e.Section IS NULL) OR (e.Site='$catalogue' AND ($sub_cond)) OR (($sub_cond) AND e.Site IS NULL) OR (e.Class='$cc' AND e.Object='$message') OR (e.Class='$cc' AND e.Object IS NULL))";

        $field_cond = "AND g.Class_ID=${BANNER_TABLE} AND g.TypeOfData_ID=6 AND g.Field_Name='File'";


        $conditions = "${campaign_cond} ${zone_cond} ${banner_cond} ${script_cond} ${field_cond}";

        if (!$rand)
        {
            $res_sort="a.LastShow";
        }
        else {
		$res_sort="RAND()";
	}

        $final_select = "SELECT $fields FROM $tables WHERE $conditions ORDER BY ".$res_sort." LIMIT 1";
        $res = $db->get_row($final_select,ARRAY_N);

        if (!$db->num_rows)
        {
            return;
        }
        list($banner_id, $campaign_id, $banner_type, $banner_size, $banner_file, $banner_alt, $banner_text, $field_id, $banner_new_window) = $res;

        $old_banID[]=$banner_id;

        list($banner_width,$banner_height) = explode("x",$banner_size);
        list($banner_filename,$banner_filesize,$banner_fileformat) = explode(":",$banner_file);

        //Virt_Name File_Path
        $banner_realname = $db->get_var("SELECT CONCAT(File_Path,Virt_Name) FROM Filetable WHERE Real_Name='".$banner_filename."'",ARRAY_N);

        //  

        $q = $db->get_var("SELECT CONCAT(File_Path,Virt_Name) FROM Filetable WHERE Field_ID = '$field_id' AND Message_ID = '$banner_id'");

	$banner_fileext = strrchr($banner_filename,".");
        $realfilename = $HTTP_FILES_PATH . ($q ? $q : $field_id."_".$banner_id.$banner_fileext);


        $url_for_stats = "http://".$HTTP_HOST.$REQUEST_URI;
        $url_p = parse_url($url_for_stats);

        $url_for_stats = $url_p['host'].$url_p['path'];

        $random_value = md5(uniqid(rand(),true));

        $click_url = "http://{$HTTP_HOST}/netcat/modules/banner/?b={$banner_id}&c={$campaign_id}&z={$zone}&r={$url_for_stats}&rnd={$random_value}&click=1";
        $click_target = $banner_new_window ? "_blank": "_self";

        switch ($banner_type)
        {
            case 1:
                $code  = "<a target='{$click_target}' href='/netcat/modules/banner/?b={$banner_id}&c={$campaign_id}&z={$zone}&r={$url_for_stats}&rnd={$random_value}&click=1'>";
                $code .= "<img border='0' src='{$realfilename}' width='{$banner_width}' height='{$banner_height}' alt='{$banner_alt}'></a>";
                break;

            case 2:
                $click_url = urlencode($click_url);

                $code  = "<object classid='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' codebase='http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0' width='{$banner_width}' height='{$banner_height}' id='banner{$banner_id}'>";
                $code .= "<param name='movie' value='{$realfilename}?banner_url={$click_url}&banner_target={$click_target}'>";
                $code .= "<param name='quality' value='high'>";
                $code .= "<param name='FlashVars' value='banner_url={$click_url}&banner_target={$click_target}'>";
                $code .= "<embed src='{$realfilename}?banner_url={$click_url}&banner_target={$click_target}' name='banner{$banner_id}' quality='high' bgcolor='ffffff' width='{$banner_width}' height='{$banner_height}' type='application/x-shockwave-flash' pluginspage='http://www.macromedia.com/go/getflashplayer'></embed>";
                $code .= "</object>";
                break;

            case 3:
                $code = $banner_text;
                $code = str_replace("%banner_url%", $click_url, $code);
                $code = str_replace("%banner_target%", $click_target, $code);
                break;
        }

        $adm_mode = ($admin_mode ? "&adm=1" : "");

        $code .= "<img src='/netcat/modules/banner/index.php?rnd={$random_value}&c={$campaign_id}&z={$zone}&b={$banner_id}&r={$url_for_stats}{$adm_mode}' width='1' height='1'>";
        $final_code .=$code;
    }
    return ($final_code);

}

function banner_zone ($size_id,$priority) {
    global $db, $MODULE_VARS;
    global $catalogue, $sub, $cc, $message, $action;

    extract ($MODULE_VARS['banner']);

    if ($size_id) $size_cond = "Size='".$size_id."'"; else $size_cond = "Size IS NULL";
    $select = "SELECT Message_ID FROM Message".$ZONE_TABLE." WHERE $size_cond AND ";

    $site_cond = "Site=$catalogue";
    $section_cond = "(".banner_getparentsections ($sub,"Section","Section='$sub' ").")";
    $message_cond = "Class=$cc AND Object=$message";

    if ($cc && $message && $action=="full")
    $where = $message_cond;
    else
    $where = $section_cond;

    $limit = " LIMIT $priority,1";

    $res = $db->get_var($select.$where.$limit);
    if (!$db->num_rows) {
        $res = $db->get_var($select.$section_cond.$limit);
        if (!$db->num_rows) {
            $res = $db->get_var($select.$site_cond.$limit);
            if (!$db->num_rows) return false;
        }
    }
    $zone = $res;


    return $zone;
}

function banner_stats ($campaign,$zone,$banner,$referer,$rnd,$click) {
    global $db, $MODULE_VARS, $REMOTE_ADDR, $HTTP_USER_AGENT;

    $current_url = urldecode($referer);
    extract($MODULE_VARS['banner']);

    if (!$click)
    {
        $db->query("UPDATE Message${CAMPAIGN_TABLE} SET Showed=Showed+1,LastUpdated=LastUpdated WHERE Message_ID='$campaign'");
        $db->query("INSERT INTO Banner_Log (Campaign_ID,Zone_ID,Banner_ID,Referer,IP,UserAgent,Code) VALUES ($campaign,$zone,$banner,'".$current_url."','".$REMOTE_ADDR."','".$HTTP_USER_AGENT."','".$rnd."')");

        list($microsec,$sec) = explode(" ",microtime());
        $full_time = $sec + $microsec;

        $db->query("UPDATE Banner_CampaignBanner SET LastShow=".$full_time." WHERE Campaign_ID='$campaign' AND Banner_ID='$banner'");
    } else {
        $db->query("UPDATE Banner_Log SET Clicked=1 WHERE Campaign_ID='$campaign' AND Zone_ID='$zone' AND Banner_ID='$banner' AND Referer='".$current_url."' AND DATE_FORMAT(Created, '%Y-%m-%d')=DATE_FORMAT(CURDATE(),'%Y-%m-%d') AND IP='".$REMOTE_ADDR."' AND UserAgent='".$HTTP_USER_AGENT."' AND Code='".$rnd."'");

    }
}

function banner_url ($id)
{
    global $db, $MODULE_VARS;

    extract ($MODULE_VARS['banner']);

    $res = $db->get_var("SELECT Link FROM Message${BANNER_TABLE} WHERE Message_ID='$id'");
    if ($db->num_rows) {
        $link = $res;
    }
    return $link;
}

function banner_getparentsections($sub, $field, $query)
{
    global $db;

    $parent = $db->get_var("SELECT Parent_Sub_ID FROM Subdivision WHERE Subdivision_ID=$sub");

    if (!$parent) return $query;

    $query .= " OR $field='".$parent."'";

    $query = banner_getparentsections ($parent,$field,$query);
    return $query;
}

function banner_CreateReports()
{
    global $db;

    banner_CreateReportBanner();
    banner_CreateReportCampaign();
    banner_CreateReportZone();
    banner_CreateReportReferer();

    $db->query("DELETE FROM Banner_Log WHERE DATE_FORMAT(Created, '%Y-%m-%d') < DATE_FORMAT(CURRENT_DATE(),'%Y-%m-%d')");
}

function banner_CreateReportBanner()
{
    global $db;

    $db->query("DELETE FROM Banner_StatsBanner WHERE Date=CURRENT_DATE()");
    $db->query("INSERT IGNORE INTO Banner_StatsBanner (Date,Hour,Banner_ID,Shows,Clicks) SELECT DATE_FORMAT(Created, '%Y-%m-%d') AS Date, DATE_FORMAT(Created, '%H') AS Hour, Banner_ID, COUNT(*), SUM(Clicked) FROM Banner_Log GROUP BY Date, Hour, Banner_ID");
}

function banner_CreateReportCampaign()
{
    global $db;

    $db->query("DELETE FROM Banner_StatsCampaign WHERE Date=CURRENT_DATE()");
    $db->query("INSERT IGNORE INTO Banner_StatsCampaign (Date,Hour,Campaign_ID,Shows,Clicks) SELECT DATE_FORMAT(Created, '%Y-%m-%d') AS Date, DATE_FORMAT(Created, '%H') AS Hour,Campaign_ID,COUNT(*),SUM(Clicked) FROM Banner_Log GROUP BY Date,Hour,Campaign_ID");
}

function banner_CreateReportZone()
{
    global $db;

    $db->query("DELETE FROM Banner_StatsZone WHERE Date=CURRENT_DATE()");
    $db->query("INSERT IGNORE INTO Banner_StatsZone (Date,Hour,Zone_ID,Shows,Clicks) SELECT DATE_FORMAT(Created, '%Y-%m-%d') AS Date, DATE_FORMAT(Created, '%H') AS Hour,Campaign_ID,COUNT(*),SUM(Clicked) FROM Banner_Log GROUP BY Date,Hour,Zone_ID");
}

function banner_CreateReportReferer()
{
    global $db;

    $db->query("DELETE FROM Banner_StatsReferer WHERE Date=CURRENT_DATE()");
    $db->query("INSERT IGNORE INTO Banner_StatsReferer (Date,Referer,Shows,Clicks) SELECT DATE_FORMAT(Created, '%Y-%m-%d') AS Date,Referer,COUNT(*),SUM(Clicked) FROM Banner_Log GROUP BY Date,Referer");
}

?>