<?
  if (!$shop_id) die("NO SHOP ID.");
  if (!$catalogue_id && !$subdivisions) die("Neither CATALOGUE_ID nor SUBDIVISIONS supplied.");

  //    $shop_id [  $cc]  $goods_types   $subdivisions
  //   $selected (type_id:goods_id) 

  error_reporting(E_ALL^E_NOTICE);

  require_once("../../../vars.inc.php");
  require_once("../../../admin/function.inc.php");
  require_once("../../../admin/classificator.inc.php");
  require_once($INCLUDE_FOLDER."s_loadenv.inc.php");
  if ( !($perm->isSupervisor() || $perm->isGuest()) ) { die("NO RIGHTS"); }
  LoadModuleEnv();

?>
<html>
<head>
<title></title>
<script>
function save()
{
   var val = [], src = document.form.goods;

   for (j=0; j < src.options.length; j++)
   {
       if (src.options[j].selected) val.push(src.options[j].value);
   }
   parent.document.adminForm.f_Goods.value = val.join(",");
}
</script>
</head>

<body leftmargin=0 topmargin=0>


<form name=form style="margin:0">
<select multiple name=goods style="width:100%; height:100%" onchange="save()">
<?

if (!$goods_types)
{
   $goods_types = assoc_array("SELECT DISTINCT c.Class_ID
                               FROM Class as c, Field as f
                               WHERE c.Class_ID=f.Class_ID
                                 AND f.Field_Name LIKE 'Price%'
                                 AND c.Class_Group='Netshop'
                               ORDER BY c.Class_ID
                                        ");
}
else
{
   $goods_types = explode(",", $goods_types);
}


$struct = GetStructure($shop_id, "Checked=1", ($subdivisions ? "get_children" : "plain"));

$subdiv_ids = array();
if ($subdivisions)
{
   $subdivisions = explode(",", $subdivisions);
   foreach ($subdivisions as $subdivision)
   {
      $subdiv_ids = array_merge(array($subdivision), $subdiv_ids, $struct[$subdivision]["Children"]);
   }
   $subdiv_ids = join(",", $subdiv_ids);
}

$goods = array();
foreach ($goods_types as $goods_type)
{
   if ($subdivisions)
   {
      $res = assoc_array("SELECT m.Message_ID, m.Name, m.ItemID
                          FROM Message$goods_type as m, Sub_Class as sc
                          WHERE m.Checked=1
                            AND m.Sub_Class_ID=sc.Sub_Class_ID
                            AND sc.Subdivision_ID IN ($subdiv_ids)");
   }
   else
   {
      $res = assoc_array("SELECT m.Message_ID, m.Name, m.ItemID
                          FROM Message$goods_type as m, Sub_Class as sc
                          WHERE m.Checked=1
                            AND  m.Sub_Class_ID=sc.Sub_Class_ID
                            AND sc.Catalogue_ID=$catalogue_id
                          ORDER BY m.Name");
   }

   $tp = ",$selected,";
   foreach ($res as $row)
   {
      print "<option value='$goods_type:$row[Message_ID]'";
      if ($selected && strpos($tp, ",$goods_type:$row[Message_ID],")!==false) print " selected";
      print ">[$row[ItemID]] $row[Name]\n";
   }

}

?>
</select>
</form>
</body>
</html>
